/**************************************************************************
 *   Inferno : An automatic semantic information extractor                 *
 *   Copyright (C) 2006-2010  University of Michigan                       *
 *   http://www.eecs.umich.edu/inferno                                     *
 *                                                                         *
 *   Contributors include Andrew DeOrio, Adam Bauserman,                   *
 *   Valeria Bertacco and Beth Isaksen.                                    *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         *
 *   02110-1301  USA                                                       *
 *                                                                         *
 *   Andrew DeOrio <awdeorio@umich.edu>                                    *
 *   Valeria Bertacco <valeria@umich.edu>                                  *
 *                                                                         *
 *   University of Michigan                                                *
 *   Electrical Engineering and Computer Science Dept.                     *
 *   2260 Hayward St.                                                      *
 *   Ann Arbor, MI 48109-2121                                              *
 **************************************************************************/

#ifndef CONFIG_PARSER_H
#define CONFIG_PARSER_H

#include <string>
#include <vector>
#include <map>
#include <set>
#include <iostream>
#include <fstream>

#include "global_defs.h"
#include "global_vars.h"

class Config_Parser {

 public:

  string config_file_name;

  Config_Parser(const string& config_file_name_in);
  ~Config_Parser();

  bool parse(string& output_file_base, string& top_name, int& max_lines, string& reset_name,
             string& clock_name, bool& transaction_mode, bool& sync_mode, bool& signal_mode,
             bool& all_signals, bool& start_mode, vector<string>& start_signal_names,
             vector<string>& start_triggers, vector<string>& verilog_f_names, 
             string& trace_file_name, int& max_bits, string& main_module,
             set<string>& signals_to_analyze, set<string>& modules_to_analyze,
             bool& loopback_edges, vector<string>& ignore_states, bool& show_hex,
             bool& strip_leading_zeros);
  void print_help();
                                        
 private:
};

#endif //CONFIG_PARSER_H
