/**************************************************************************
 *   Inferno : An automatic semantic information extractor                 *
 *   Copyright (C) 2006-2010  University of Michigan                       *
 *   http://www.eecs.umich.edu/inferno                                     *
 *                                                                         *
 *   Contributors include Andrew DeOrio, Adam Bauserman,                   *
 *   Valeria Bertacco and Beth Isaksen.                                    *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         *
 *   02110-1301  USA                                                       *
 *                                                                         *
 *   Andrew DeOrio <awdeorio@umich.edu>                                    *
 *   Valeria Bertacco <valeria@umich.edu>                                  *
 *                                                                         *
 *   University of Michigan                                                *
 *   Electrical Engineering and Computer Science Dept.                     *
 *   2260 Hayward St.                                                      *
 *   Ann Arbor, MI 48109-2121                                              *
 **************************************************************************/

#include <iostream>
#include <vector>

#include "FourValuedLogic.h"

using namespace std;

#ifndef FOURVALUEDVECTOR_H
#define FOURVALUEDVECTOR_H

class FourValuedVector : public vector<FourValuedLogic> {
 public:

  FourValuedVector();
  FourValuedVector(const FourValuedLogic& val);
  FourValuedVector(const string& val);
  FourValuedVector(const string& val,int num_reps);
  ~FourValuedVector();
        
  void print();
  bool is_one() const
  { return (size() == 1 && front() == FourValuedLogic('1')); }
  bool is_zero() const
  { return (size() == 1 && front() == FourValuedLogic('0')); }
  void negate();
  string get_string_w_dont_cares(bool show_hex, bool strip_leading_zeros) const;
  FourValuedVector operator~() const;
  bool operator==(const FourValuedVector& v) const;

  friend ostream& operator<<(ostream &os, const FourValuedVector &v);
};

// extern const FourValuedVector VECTOR_0;
// extern const FourValuedVector VECTOR_1;

#endif //FOURVALUEDVECTOR_H
