/**************************************************************************
 *   Inferno : An automatic semantic information extractor                 *
 *   Copyright (C) 2006-2010  University of Michigan                       *
 *   http://www.eecs.umich.edu/inferno                                     *
 *                                                                         *
 *   Contributors include Andrew DeOrio, Adam Bauserman,                   *
 *   Valeria Bertacco and Beth Isaksen.                                    *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         *
 *   02110-1301  USA                                                       *
 *                                                                         *
 *   Andrew DeOrio <awdeorio@umich.edu>                                    *
 *   Valeria Bertacco <valeria@umich.edu>                                  *
 *                                                                         *
 *   University of Michigan                                                *
 *   Electrical Engineering and Computer Science Dept.                     *
 *   2260 Hayward St.                                                      *
 *   Ann Arbor, MI 48109-2121                                              *
 **************************************************************************/

#ifndef LOOP_H
#define LOOP_H

#include <vector>
#include <string>
#include <set>
#include <iostream>
#include <algorithm>

using namespace std;

class Loop
{
 public:
  vector<int> sequence;
  int min_times, max_times;
        
  Loop() {}
  //    Loop(int min_times_in, int max_times_in, const vector<int>& sequence_in);
  virtual ~Loop() {}

  vector<int>::iterator find_loop(Loop& l) {
    vector<int>::iterator it, cur_begin, it2 = l.sequence.begin(), comp_begin;
    comp_begin = it2;
    it = find(sequence.begin(),sequence.end(),*comp_begin);
    cur_begin = it;
    while(it != sequence.end()) {
      while(it != sequence.end() && it2 != l.sequence.end() && *it == *it2) {
        ++it;
        ++it2;
      }
      if(it2 == l.sequence.end()) {
        return cur_begin;
      }
      else if(it != sequence.end()) {
        ++cur_begin;
        it = find(cur_begin,sequence.end(),*comp_begin);
        cur_begin = it;
        it2 = comp_begin;
      }
    }
    return sequence.end();
  }

  void remove(Loop& l) {
    vector<int>::iterator begin, end;
    begin = find_loop(l);
    while(begin != sequence.end()) {
      end = begin;
      unsigned int size = l.sequence.size();
      unsigned int i = 0;
      while(i < size - 1 && end != sequence.end()) {
        ++i;
        ++end;
      }
      sequence.erase(begin,end);
      begin = find_loop(l);
    }
  }
        
  bool operator==(const Loop& l) const
  { return (min_times == l.min_times && max_times == l.max_times && sequence == l.sequence); }

  //    friend ostream& operator<<(ostream &os, const Loop &t);
 private:
};

#endif // LOOP_H
