/**************************************************************************
 *   Inferno : An automatic semantic information extractor                 *
 *   Copyright (C) 2006-2010  University of Michigan                       *
 *   http://www.eecs.umich.edu/inferno                                     *
 *                                                                         *
 *   Contributors include Andrew DeOrio, Adam Bauserman,                   *
 *   Valeria Bertacco and Beth Isaksen.                                    *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         *
 *   02110-1301  USA                                                       *
 *                                                                         *
 *   Andrew DeOrio <awdeorio@umich.edu>                                    *
 *   Valeria Bertacco <valeria@umich.edu>                                  *
 *                                                                         *
 *   University of Michigan                                                *
 *   Electrical Engineering and Computer Science Dept.                     *
 *   2260 Hayward St.                                                      *
 *   Ann Arbor, MI 48109-2121                                              *
 **************************************************************************/

#include "Module_Child.h"

Module_Child::Module_Child()
{
}

Module_Child::~Module_Child()
{
}

void Module_Child::clear() {
  type = "";
  name = "";
  connections.clear();
}

string Module_Child::get_global_name(const string& signal_name) const {
  //    cout << "Module_Child " << name << " get_global_name\n";
  for(connections_t::const_iterator it = connections.begin();
      it != connections.end(); ++it) {
    //          cout << "comparing to " << it->first << endl;
    if(it->first == signal_name)
      return it->second;
  }
  return "";
}

string Module_Child::get_local_name(const string& signal_name) const {
  //    cout << "Module_Child " << name << " get_global_name\n";
  for(connections_t::const_iterator it = connections.begin();
      it != connections.end(); ++it) {
    //          cout << "comparing to " << it->first << endl;
    if(it->second == signal_name)
      return it->first;
  }
  return "";
}

bool Module_Child::has_global_name(const string& global_name) const {
  //    cout << "Module_Child " << name << " has_global_name\n";
  for(connections_t::const_iterator it = connections.begin();
      it != connections.end(); ++it) {
    //          cout << "comparing to " << it->second << endl;
    if(it->second == global_name) {
      return true;
    }
  }
  return false;
}

ostream& operator<<(ostream &os, const Module_Child &m) {
  os << "\t\t" << m.name << endl;

  os << "\t\tConnections:\n";
  for(connections_t::const_iterator it = m.connections.begin();
      it != m.connections.end(); ++it) {
    os << "\t\t\t" << it->first << " -> " << it->second << "\n";
  }
        
  return os;
}
