/**************************************************************************
 *   Inferno : An automatic semantic information extractor                 *
 *   Copyright (C) 2006-2010  University of Michigan                       *
 *   http://www.eecs.umich.edu/inferno                                     *
 *                                                                         *
 *   Contributors include Andrew DeOrio, Adam Bauserman,                   *
 *   Valeria Bertacco and Beth Isaksen.                                    *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         *
 *   02110-1301  USA                                                       *
 *                                                                         *
 *   Andrew DeOrio <awdeorio@umich.edu>                                    *
 *   Valeria Bertacco <valeria@umich.edu>                                  *
 *                                                                         *
 *   University of Michigan                                                *
 *   Electrical Engineering and Computer Science Dept.                     *
 *   2260 Hayward St.                                                      *
 *   Ann Arbor, MI 48109-2121                                              *
 **************************************************************************/

#include "Multi_Stream.h"


Multi_Stream::Multi_Stream()
{
  mode = 0;
    
  //AddStream(cout);
}

int Multi_Stream::AddStream(ostream* stream)
{
    streams.push_back(stream);
    return streams.size()-1;
}

void Multi_Stream::SetMode(int flags)
{
    mode = flags;
}

void Multi_Stream::ActivateStream(int index)
{
    mode |= 1<<index;
}

void Multi_Stream::DeactivateStream(int index)
{
    mode &= ~(1<<index);
}


Multi_Stream& Multi_Stream::operator<<(
                                       std::basic_ostream<char, std::char_traits<char> >& 
                                       (*pf)(std::basic_ostream<char, std::char_traits<char> >&))
{
  int flags = 1;
    for(unsigned int i=0;i<streams.size();i++)
    {
      if(flags & mode)
                          // ignore requests to flush buffer, just output \n instead
        //(*streams[i]) << "\n";
                          (*pf)(*streams[i]);
      flags <<= 1;
    }
    return *this;
}
