/******************************************************************************
 * inferno                                                                    *
 *                                                                            *
 * by Andrew DeOrio, Adam Bauserman, Valeria Bertacco and Beth Isaksen        *
 *                                                                            *
 ******************************************************************************/

#ifndef VCD_PARSER_H
#define VCD_PARSER_H

#include <string>
#include <vector>
#include <map>
#include <iostream>
#include <fstream>

#include "global_defs.h"
#include "Module.h"

class VCD_Parser {

 public:
  bool parseBegin(ifstream& inFile,data_t & data, dup_t& duplicates,
                  map<string,vector<string> >& var_translation, const set<string>& modules_to_analyze);
  bool parseContinue(ifstream& inFile,data_t & data, dup_t& duplicates, const map<string,vector<string> >& var_translation,
                     bool& valuesDone, vector<string>& last_words, const modules_t& modules,
                     const map<string,string>& module_name_to_type_translation, int& lines,
                     const string& clock_name, const set<string>& modules_to_analyze,
                     bool signal_mode, bool all_signals,
                     const set<string>& signals_to_analyze, bool sync_mode);
  void readDefinitions(ifstream& inFile, data_t & data,
                       dup_t& duplicates, map<string,vector<string> >& var_translation,
                       const set<string>& modules_to_analyze);
  bool readScope(ifstream& inFile, vector<string>& scope, data_t & data,
                 dup_t& duplicates, map<string,vector<string> >& var_translation,
                 const set<string>& modules_to_analyze, vector<string>& last_words);
  bool readValues(ifstream &inFile, data_t& data,
                  const map<string,vector<string> >& var_translation, int max_lines, vector<string>& last_words,
                  const modules_t& modules,
                  const map<string,string>& module_name_to_type_translation, int& count,
                  const string& values, const set<string>& modules_to_analyze,
                  bool signal_mode, bool all_signals,
                  const set<string>& signals_to_analyze, bool sync_mode);

};

#endif //VCD_PARSER_H
