module legal_transition_assertion(clock, reset, fail);

   input reset;

   output fail;



   reg [3:0] legal_transaction;
   reg [3:0] legal_transaction_last;

   wire legal_transition;

   wire transaction_0_legal_transitions;
   wire transaction_1_legal_transitions;
   wire transaction_2_legal_transitions;
   wire transaction_3_legal_transitions;
   wire legal_end_last;


   assign fail = ~legal_transition;

   assign legal_transition =   legal_transaction_last[0]
			     | legal_transaction_last[1]
			     | legal_transaction_last[2]
			     | legal_transaction_last[3];

   assign transaction_0_legal_transitions = 1;
   assign transaction_1_legal_transitions = 1;
   assign transaction_2_legal_transitions = 1;
   assign transaction_3_legal_transitions = 1;
   assign legal_end_last = 1;

   always @(posedge clock)
     begin



         legal_transaction_last[0] <= (~reset & legal_transaction[0] & (legal_end_last | legal_transaction_last[0]));
         legal_transaction_last[1] <= (~reset & legal_transaction[1] & (legal_end_last | legal_transaction_last[1]));
         legal_transaction_last[2] <= (~reset & legal_transaction[2] & (legal_end_last | legal_transaction_last[2]));
         legal_transaction_last[3] <= (~reset & legal_transaction[3] & (legal_end_last | legal_transaction_last[3]));

     end //else
   end //always

//synopsys translate_off
   always @(posedge clock)
     begin

     casex(transaction_0transitions)
       1'b0 : legal_transaction[0] = 1'b0;
       1'b1 : legal_transaction[0] = 1'b1;
     endcase
     casex(transaction_1transitions)
       1'b0 : legal_transaction[1] = 1'b0;
       1'b1 : legal_transaction[1] = 1'b1;
     endcase
     casex(transaction_2transitions)
       1'b0 : legal_transaction[2] = 1'b0;
       1'b1 : legal_transaction[2] = 1'b1;
     endcase
     casex(transaction_3transitions)
       1'b0 : legal_transaction[3] = 1'b0;
       1'b1 : legal_transaction[3] = 1'b1;
     endcase

     end //always
//synopsys translate_on

// synopsys translate_off
  always @(fail) begin
    if (fail == 1'b1) $display("Error: checker failure: %m");
  end
// synopsys translate_on
endmodule
