/////////////////////////////////////////////////////////////////////////////
//   Inferno : An automatic semantic information extractor                 //
//   Copyright (C) 2006-2010  University of Michigan                       //
//   http://www.eecs.umich.edu/inferno                                     //
//                                                                         //
//   Contributors include Andrew DeOrio, Adam Bauserman,                   //
//   Valeria Bertacco and Beth Isaksen.                                    //
//                                                                         //
//   This library is free software; you can redistribute it and/or         //
//   modify it under the terms of the GNU Lesser General Public            //
//   License as published by the Free Software Foundation; either          //
//   version 2.1 of the License, or (at your option) any later version.    //
//                                                                         //
//   This library is distributed in the hope that it will be useful,       //
//   but WITHOUT ANY WARRANTY; without even the implied warranty of        //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     //
//   Lesser General Public License for more details.                       //
//                                                                         //
//   You should have received a copy of the GNU Lesser General Public      //
//   License along with this library; if not, write to the Free Software   //
//   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         //
//   02110-1301  USA                                                       //
//                                                                         //
//   Andrew DeOrio <awdeorio@umich.edu>                                    //
//   Valeria Bertacco <valeria@umich.edu>                                  //
//                                                                         //
//   University of Michigan                                                //
//   Electrical Engineering and Computer Science Dept.                     //
//   2260 Hayward St.                                                      //
//   Ann Arbor, MI 48109-2121                                              //
/////////////////////////////////////////////////////////////////////////////

module ps2_nolatch(clk,req,en,gnt);
   input       clk;
   input[1:0]  req;
   input       en;
   output[1:0] gnt;
   
   assign      gnt[1] = en && req[1];
   assign      gnt[0] = en && ~req[1] && req[0];
endmodule


module ps2_latch(clk,req,en,gnt);
   input       clk;
   input [1:0] req;
   input       en;
   wire  [1:0] gnt_tmp;
   output[1:0] gnt;
   reg   [1:0] gnt_delayed;

   assign      gnt_tmp[1] = en && req[1];
   assign      gnt_tmp[0] = en && ~req[1] && req[0];

   always @(posedge clk)
   begin
      gnt_delayed <= #1 gnt_tmp;
   end

   assign      gnt = gnt_delayed;

endmodule
