/////////////////////////////////////////////////////////////////////////////
//   Inferno : An automatic semantic information extractor                 //
//   Copyright (C) 2006-2010  University of Michigan                       //
//   http://www.eecs.umich.edu/inferno                                     //
//                                                                         //
//   Contributors include Andrew DeOrio, Adam Bauserman,                   //
//   Valeria Bertacco and Beth Isaksen.                                    //
//                                                                         //
//   This library is free software; you can redistribute it and/or         //
//   modify it under the terms of the GNU Lesser General Public            //
//   License as published by the Free Software Foundation; either          //
//   version 2.1 of the License, or (at your option) any later version.    //
//                                                                         //
//   This library is distributed in the hope that it will be useful,       //
//   but WITHOUT ANY WARRANTY; without even the implied warranty of        //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     //
//   Lesser General Public License for more details.                       //
//                                                                         //
//   You should have received a copy of the GNU Lesser General Public      //
//   License along with this library; if not, write to the Free Software   //
//   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         //
//   02110-1301  USA                                                       //
//                                                                         //
//   Andrew DeOrio <awdeorio@umich.edu>                                    //
//   Valeria Bertacco <valeria@umich.edu>                                  //
//                                                                         //
//   University of Michigan                                                //
//   Electrical Engineering and Computer Science Dept.                     //
//   2260 Hayward St.                                                      //
//   Ann Arbor, MI 48109-2121                                              //
/////////////////////////////////////////////////////////////////////////////


module testbench;
   reg clk;
   reg [1:0] req;
   reg  en;
   wire [1:0] gnt;
   wire [1:0] tb_gnt;
   wire correct;
   
   // printer
   always@(posedge clk)
   begin
      $display("Time:%4.0f req:%b en:%b gnt:%b", $time, req, en, gnt);
   end

   //generate system clock
   always
   begin
      #5;
      clk = ~clk;
   end

   ps2_nolatch ps2(.clk(clk),
                   .req(req),
                   .en(en),
                   .gnt(gnt));

   assign tb_gnt[1]=en&req[1];
   assign tb_gnt[0]=en&req[0]&~req[1];
   assign correct=(tb_gnt==gnt);

   
//    always @(posedge clk)
//    begin
//       if(!correct)
//       begin
//          $display("@@@ Incorrect at time %4.0f", $time);
//          $display("@@@ gnt=%b, en=%b, req=%b",gnt,en,req);
//          $display("@@@ expected result=%b", tb_gnt);
//          $finish;
//       end
//    end


   initial 
      begin
         clk=0;
         en=0;
         req=0;
         @(negedge clk);
         en=1;
         req = 2'b00;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b11;
         @(negedge clk);
         req = 2'b11;
         @(negedge clk);
         req = 2'b00;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b11;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b00;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b11;
         @(negedge clk);
         req = 2'b00;
         @(negedge clk);
         req = 2'b00;
         @(negedge clk);
         req = 2'b00;
         @(negedge clk);
         req = 2'b11;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b01;
         @(negedge clk);
         req = 2'b10;
         @(negedge clk);
         req = 2'b11;
         @(negedge clk);
         req = 2'b00;
         @(negedge clk);
         en=0;
         @(negedge clk);
         en=0;
         req = 2'b00;
         @(negedge clk);

         $finish;
      end // initial

endmodule
